<template src="./template.html"></template>
<script lang="ts">
import {
  Component,
  getModule,
  Prop,
  Vue,
  Watch,
} from "nuxt-property-decorator";

import { apiErrorHandler, redirectPage } from "~/utils/apiHanlers";
import { api } from "~/common/constaint";
@Component({
  components: {
    ListProductAdmin: () =>
      import("@/components/Utils/ListProductAdmin/index.vue"),
    Loading: () => import("@/components/Utils/Loading/index.vue"),
  },
})
export default class SellerStoreComponent extends Vue {
  data() {
    return {
      selected: [],
      date: new Date(Date.now() - new Date().getTimezoneOffset() * 60000)
        .toISOString()
        .substr(0, 10),
      searchIdItem: false,
      page: 6,
    };
  }
  listStatus = [
    {
      name: "All",
      value: "",
    },
    {
      name: "Draft",
      value: "pending",
    },
    {
      name: "Active",
      value: "active",
    },
  ];
  tableHeader = [
    { name: "Shop name" },
    { name: "Domain" },
    { name: "Status" },
    // { name: "Action" },
  ];
  limitItems = [5, , 10, , 15, , 20, , 25, , 30, , 35, , 40];
  get storeList() {
    return this.$store.state.sellerStore.storeList;
  }
  set storeList(value: any) {
    this.$store.commit("sellerStore/setStoreList", value);
  }
  get listProductAdmin() {
    return this.$store.state.sellerStore.listProductAdmin;
  }

  set listProductAdmin(value: boolean) {
    this.$store.commit("sellerStore/setListProductAdmin", value);
  }

  onDialog = false;

  openCreateStoreDialog() {
    this.listProductAdmin = true;
  }

  beforeDestroy() {
    this.listProductAdmin = false;
  }

  openDialogs = false;
  idItem = 0;
  detailProduct: any = {};
  productId = "";

  config = {
    page: 1,
    limit: 25,
    search: "",
    status: "",
  };
  totalPage: number = 1;

  dialogPassword = false;

  get loadingTableStore() {
    return this.$store.state.sellerStore.loadingTableStore;
  }

  set loadingTableStore(value: boolean) {
    this.$store.commit("sellerStore/setLoadingTableStore", value);
  }
  convertImage(url: string) {
    return `${api}/${url}`;
  }

  goToEditDetailProduct(id: any) {
    this.productId = id;
    const detailProduct = this.storeList.find(
      (item: any) => item._id === this.productId
    );
    this.urlLink = `/seller/store/${detailProduct._id}?tab=2`;
    const isCheck = this.checkAdminPassword();
    if (!isCheck) return;
    // @ts-ignore
    this.$router.push(`/seller/store/${detailProduct._id}?tab=2`);
  }

  password = "";
  isHidePassword = false;

  urlLink = "";
  checkAdminPassword() {
    this.password = "";
    const isPasswordAdmin = localStorage.getItem("isPasswordAdmin");
    if (!isPasswordAdmin) {
      this.dialogPassword = true;
      return false;
    }
    return true;
  }

  onSetPassword() {
    if (!this.password)
      return this.$pushNotification.error("Please enter password");
    if (this.password === "zshopoverview2023@@!*") {
      this.$store.commit("product/checkIsCorrectPassword", true);
      localStorage.setItem("isPasswordAdmin", this.password);
      this.dialogPassword = false;
      this.$pushNotification.success("Correct password");
      this.$router.push(this.urlLink);
    } else {
      this.$pushNotification.error("Incorrect password");
    }
  }

  goToViewDetailProduct(id: any) {
    this.productId = id;
    const detailProduct = this.storeList.find(
      (item: any) => item._id === this.productId
    );
    this.urlLink = `/seller/store/${detailProduct._id}?tab=0`;
    const isCheck = this.checkAdminPassword();
    if (!isCheck) return;
    // @ts-ignore
    this.$router.push(`/seller/store/${detailProduct._id}?tab=0`);
  }

  goToDuplicateDetailProduct(id: any) {
    this.productId = id;
    const detailProduct = this.storeList.find(
      (item: any) => item._id === this.productId
    );
    this.urlLink = `/seller/store/duplicate/${detailProduct._id}`;
    const isCheck = this.checkAdminPassword();
    if (!isCheck) return;
    // @ts-ignore
    this.$router.push(`/seller/store/duplicate/${detailProduct._id}`);
  }
  mounted() {
    this.onGetStoreList();
  }
  searchStore = "";

  async onGetStoreList() {
    try {
      this.$store.commit("sellerStore/setStoreList", []);
      let query = {
        ...this.config,
      };
      this.loadingTableStore = true;
      const res = await this.$api.store.list(query);
      if (res?.data) {
        const { total } = res.data;
        this.totalPage = Math.ceil(total / this.config.limit);
        this.storeList = res.data.data;
        this.$store.commit("sellerStore/setStoreList", res.data.data);
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTableStore = false;
    }
  }

  async onChangeStatus(item: any, status: string) {
    try {
      const body = {
        storeId: item._id,
        status,
      };
      await this.$api.store.changeStatus(body);
      this.$pushNotification.success("Change status successfully");
      this.onGetStoreList();
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  @Watch("config.page")
  changedPage() {
    this.onGetStoreList();
  }
}
</script>

<style src="./style.scss" lang="scss"></style>
